<?php

defined('_JEXEC') or die();

jimport( 'joomla.application.component.model' );
jimport('joomla.filesystem.file');

class GetMailingModelExportar extends JModel {

    /**
     * 'r' - Abre somente para leitura; coloca o ponteiro no começo do arquivo.
     * 'r+' - Abre para leitura e gravação; coloca o ponteiro no começo do arquivo.
     * 'w' - Abre somente para gravação; coloca o ponteiro no começo do arquivo e apaga o conteúdo que já foi escrito. Se o arquivo não existir, tentar criá-lo.
     * 'w+' - Abre para leitura e escrita; coloca o ponteiro no início do arquivo e apaga o conteúdo que já foi escrito. Se o arquivo não existir, tentar criá-lo.
     * 'a' - Abre o arquivo somente para escrita; coloca o ponteiro no fim do arquivo. Se o arquivo não existir, tentar criá-lo.
     * 'a+' - Abre o arquivo para leitura e gravação; coloca o ponteiro no fim do arquivo. Se o arquivo não existir, tentar criá-lo.
     */

    /** Salva no arquivo mailing.txt (Texto) as informações recuperadas no banco, e depois chama a
     * função responsável por fazer o download do arquivo
     */
    function exportarMailingTxt() {

        $dataAtual = date('d-m-Y - H') . 'h' . date('i');
        $arquivo = JPATH_ROOT . DS . "media" . DS . "getmailing" . DS . "GetMailing - " . $dataAtual . ".txt";

        try {

            $db =& JFactory::getDBO();

            $query = "SELECT email FROM #__getmailing WHERE published = 1 ORDER BY id ASC";

            $db->setQuery($query);

            $rows = $db->loadObjectList();

            $dados = "";

            $quebra = chr(13).chr(10);

            for ($i = 0; $i < count($rows); $i++) {

                $row = &$rows[$i];

                $dados .= $row->email . $quebra;

            }

            $fp = fopen($arquivo, "w+");

            $escreve = fwrite($fp, $dados);

            fclose($fp);

            $this->downloadArquivos($arquivo);

        }

        catch(Exception $erro) {

            $msg = JText::_('ERRO_EXPORTAR_MAILING_TXT');

            $this->setRedirect('index.php?option=com_getmailing&controller=getmailing&task=importar_exportar', $msg);

        }

    }


    /** Salva no arquivo mailing.xls (excel) as informações recuperadas no banco, e depois chama a
     * função responsável por fazer o download do arquivo
     */
    function exportarMailingExcel() {

        $dataAtual = date('d-m-Y - H') . 'h' . date('i');
        $arquivo = JPATH_ROOT . DS . "media" . DS . "getmailing" . DS . "GetMailing - " . $dataAtual . ".xls";

        try {

            $db =& JFactory::getDBO();

            $query = "SELECT nome, email, data_cadastro, published FROM #__getmailing ORDER BY id ASC";

            $db->setQuery($query);

            $rows = $db->loadObjectList();

            $dados = "

            <table border=1>
            <thead>
            <tr>
                <td style='background:#69c; font-weight:bold; text-align:center; font-size:18px; color:#fff; padding:5px;' colspan=4>GetMailing - Coleta de Mailing para Joomla!</td>
            </tr>
            <tr>
                <td style='' colspan=4></th>
            </tr>
            </thead>

            <tbody>

            <tr>
                <th style='background:#690; color:#fff; width: 260px;'>Nome:</th>
                <th style='background:#690; color:#fff; width: 350px;'>E-mail</th>
                <th style='background:#690; color:#fff; width: 130px;'>Data de Cadastro</th>
                <th style='background:#690; color:#fff; width: 100px;'>Status</th>
            </tr>

            ";

            for ($i = 0; $i < count($rows); $i++) {

                $row = &$rows[$i];

                if($i % 2 == 0)
                    $bg = 'style="background:#eee;"';

                else
                    $bg = 'style="background:#fff;"';

                $data = $row->data_cadastro;

                $data = substr($data, 8,2) . '/' . substr($data, 5,2) . '/' . substr($data, 0,4) . ' - ' . substr($data, 11,2) . ':' . substr($data, 14,2);

                if($row->published == 1)
                    $publicado = '<span style="color:#009900">Ativado</span>';

                else
                    $publicado = '<span style="color:#ff0000">Desativado</span>';

                $dados .= "<tr><td $bg>" . utf8_decode($row->nome) . "</td><td $bg>" . $row->email . "</td><td align=center $bg>" . $data . "</td><td align=center>" . $publicado . "</td></tr>";

            }

            $dados .= "
                <tr><td style='background:#fff;' colspan=4></td></tr>
		<tr><td style='background:#69c; text-align:center; font-size:10px; color:#fff;' colspan=4>Desenvolvido por Hugo Ferreira<br />www.hcferreira.com.br</td></tr>
		</tbody>
            </table>";

            //Abre o arquivo, escreve no mesmo o que foi gerado, e fecha-o
            $fp = fopen($arquivo, "w+");
            $escreve = fwrite($fp, $dados);
            fclose($fp);

            $this->downloadArquivos($arquivo);

        }

        catch(Exception $erro) {

            $msg = JText::_('ERRO_EXPORTAR_MAILING_EXCEL');
            $link = 'index.php?option=com_getmailing&controller=getmailing&task=importar_exportar';

            $this->setRedirect($link, $msg);

        }

    }

    /**
     * Exporta o Backup do Mailing para um arquivo XML, que poderá mais tarde ser restaurado pelo componente.
     * Usa a API DOM do PHP5
     */
    function exportarBackup() {

        $dataAtual = date('d-m-Y - H') . 'h' . date('i');
        $arquivo = JPATH_ROOT . DS . "media" . DS . "getmailing" . DS . "GetMailing - Backup_" . $dataAtual . ".xml";

        try {

            $db =& JFactory::getDBO();

            $query = "SELECT nome, email, uid, published, hits, data_cadastro FROM #__getmailing ORDER BY id ASC";
            $db->setQuery($query);
            $rows = $db->loadObjectList();

            $dom = new DOMDocument("1.0", "ISO-8859-1");
            $dom->preserveWhiteSpace = false;
            $dom->formatOutput = true;

            $data = "
GetMailing - Coleta de Mailing para Joomla!
Data do Backup: $dataAtual

Sistema desenvolvido por Hugo Ferreira
www.hcferreira.com.br
                    ";

            $comment = $dom->createComment($data);
            $dom->appendChild($comment);

            $root = $dom->createElement("getmailing");

            for ($i = 0; $i < count($rows); $i++) {

                $row = &$rows[$i];

                $root->appendChild($this->exportarBackupAddRegistro($dom, $row->nome, $row->email, $row->uid, $row->published, $row->hits, $row->data_cadastro));

            }
            $dom->appendChild($root);

            $dom->save($arquivo);
            $this->downloadArquivos($arquivo);

        }
        catch(Exception $erro) {

            $msg = JText::_('ERRO_EXPORTAR_BACKUP');
            $link = 'index.php?option=com_getmailing&controller=getmailing&task=importar_exportar';

            $this->setRedirect($link, $msg);

        }

    }

    /**
     * Function responsável por montar um nó do tipo 'registro' no xml, e retorná-lo
     *
     * @param DOM $document
     * @param string $nome
     * @param string $email
     * @param string $uid
     * @param int $published
     * @param int $hits
     * @param date $data_cadastro
     * @return objeto 'nó' $registro
     */
    function exportarBackupAddRegistro($document, $nome, $email, $uid, $published, $hits, $data_cadastro) {

        #criar o elemento registro
        $registro = $document->createElement("registro");

        //Criando os nós
        $nomeElm = $document->createElement("nome", $nome);
        $emailElm = $document->createElement("email", $email);
        $uidElm = $document->createElement("uid", $uid);
        $publishedElm = $document->createElement("published", $published);
        $hitsElm = $document->createElement("hits", $hits);
        $dataCadastroElm = $document->createElement("data_cadastro", $data_cadastro);

        $registro->appendChild($nomeElm);
        $registro->appendChild($emailElm);
        $registro->appendChild($uidElm);
        $registro->appendChild($publishedElm);
        $registro->appendChild($hitsElm);
        $registro->appendChild($dataCadastroElm);

        return $registro;
    }


    /**
     * Método utilizado para gerar o XML de Backup...
     * O resultado final é o mesmo que a function de cima... porém aqui trabalha-se diretamente com
     * arquivo texto... apenas renomeando sua extensão...
     * já o outro.. manipula xml usando a API DOM do PHP 5
     */
    function exportarBackup2() {

        $dataAtual = date('d-m-Y - H') . 'h' . date('i');

        $arquivo = JPATH_ROOT . DS . "media" . DS . "getmailing" . DS . "GetMailing - Backup_" . $dataAtual . ".xml";

        try {

            $db =& JFactory::getDBO();

            $query = "SELECT nome, email, uid, published, hits, data_cadastro FROM #__getmailing ORDER BY id ASC";

            $db->setQuery($query);

            $br = chr(13).chr(10);

            $rows = $db->loadObjectList();

            $comentarios = '<!--
GetMailing - Coleta de Mailing para Joomla!
Data do Backup: ' . $dataAtual . '

Sistema desenvolvido por Hugo Ferreira
www.hcferreira.com.br
-->' . $br . $br;

            $xml = '<?xml version="1.0" encoding="UTF-8"?>' . $br . $br;
            $xml .= $comentarios;
            $xml .= '<getmailing>' . $br . $br;

            for ($i = 0; $i < count($rows); $i++) {

                $row = &$rows[$i];

                $xml .= '   <registro>' . $br;

                $xml .= '       <nome>' . $row->nome . "</nome>" . $br;
                $xml .= '       <email>' . $row->email . "</email>" . $br;
                $xml .= '       <uid>' . $row->uid . "</uid>" . $br;
                $xml .= '       <published>' . $row->published . "</published>" . $br;
                $xml .= '       <hits>' . $row->hits . "</hits>" . $br;
                $xml .= '       <data_cadastro>' . $row->data_cadastro . "</data_cadastro>" . $br;

                $xml .= '   </registro>' . $br . $br;

            }
            $xml .= '</getmailing>';

            //Abre o arquivo, escreve o que foi gerado no mesmo, fecha-o e chama o método que abre a janela para salvar ou abrir
            $fp = fopen($arquivo, "w+");
            $escreve = fwrite($fp, $xml);
            fclose($fp);

            $this->downloadArquivos($arquivo);

        }
        catch(Exception $erro) {

            $msg = JText::_('ERRO_EXPORTAR_BACKUP');
            $link = 'index.php?option=com_getmailing&controller=getmailing&task=importar_exportar';

            $this->setRedirect($link, $msg);
        }
    }


    /**
     * Função responsável por abrir a janela com opção de Abrir ou Salvar o arquivo no computador do usuário
     *
     */
    function downloadArquivos($arquivo) {

        // Pega a extensão do arquivo
        $ext = pathinfo($arquivo,PATHINFO_EXTENSION);

        // No vetor abaixo são setados os Mime Types dos possíveis arquivos
        $mimeType = array(
                'mp3' => 'audio/mpeg',
                'pdf' => 'application/pdf',
                'doc' => 'application/msword',
                'ppt' => 'application/vnd.ms-powerpoint',
                'pps' => 'application/vnd.ms-powerpoint',
                'xls' => 'application/vnd.ms-excel',
                'txt' => 'text/plain',
                'pdf' => 'application/pdf',
                'zip' => 'application/zip',
                'xml' => 'application/xml '
        );

        //Seta o Mime Type do arquivo de acordo com a extensão
        if(array_key_exists($ext,$mimeType)) {

            $mimeType = $mimeType[$ext];

        } else {

            // Se o Mime Type não for encontrado na lista, será usado o padrão application/octet-stream
            //$mimeType = "application/force-download";

            $mimeType = "application/octet-stream";

        }

        // Seta os cabeçalhos
        header( "Pragma: public" );
        header( "Expires: 0" );
        header( "Cache-Control: must-revalidate, post-check=0, pre-check=0" );
        header( "Cache-Control: private",false );
        header( "Content-Type: $mimeType" );

        // A linha abaixo é responsável por dizer que o arquivo é para download
        header( "Content-Disposition: attachment; filename=\"".basename($arquivo)."\";");

        header( "Content-Transfer-Encoding: binary" );

        header( "Content-Length: ".filesize($arquivo));

        // Lê e escreve o conteúdo do arquivo para o buffer de saída
        readfile($arquivo);

        exit;
    }

    /**
     * Recebe o arquivo txt com mailing, faz as manipulações necessárias, valida os dados e faz a importação
     * do mailing para o GetMailing
     *
     * Anotações:
     * $ext =  JFile::getExt($filename);
     * $name = JFile::stripExt($filename);
     * $safefilename = JFile::makeSafe($filename);
     * JFile::copy($src, $dest);
     * JFile::delete($path.$file);
     * JFile::upload($src, $dest);
     */
    function importarMailingTxt() {

        $retorno = true;

        $arquivo =  JRequest::getVar('mailing_txt',  null, 'files', 'array');

        $extensao = JFile::getExt($arquivo['name']);
        $nomeArquivo = "getmailing_importar." . $extensao;

        $localDestino =  JPATH_ROOT.DS."media".DS."getmailing".DS. $nomeArquivo;

        $dirTemp = $arquivo['tmp_name'];

        if ( $extensao == "txt") {

            if(JFile::upload($dirTemp, $localDestino)) {

                $arq = fopen($localDestino,'r');
                $uid = md5(time());

                //Instanciando um objeto da classe JFactory, para fazer interação com o BD
                $db =& JFactory::getDBO();

                while(!feof ($arq)) { // Enquanto não chegar no final do arquivo, lê linha por linha e add no BD

                    $email = trim(fgets($arq));

                    $query = "insert into #__getmailing (nome, email, uid, published, hits, data_cadastro) values ('" . $email . "', '" . $email . "', '" . $uid . "', 1, 0, now()); ";

                    $db->setQuery($query);
                    //Se conseguir executar a query, então terá importado tudo corretamente, mantendo a variável $retorno com seu valor inicial, true;
                    if(!$db->query()) {
                        $retorno = false;
                    }
                }

            }
            else
                $retorno = false;

        }
        else {
            $retorno = false;
        }

        return $retorno;

    }


    /**
     * Recebe o endereço do arquivo selecionado para restaurar o backup, valida tal arquivo...
     * Se for um XML, abre-o e tenta restaurar os registros que existirem no BD
     *
     * @return boolean
     */
    function restaurarBackup() {

        $retorno = true;

        $arquivo =  JRequest::getVar('backup_getmailing',  null, 'files', 'array');

        $extensao = JFile::getExt($arquivo['name']);
        $nomeArquivo = "getmailing_backup." . $extensao;

        $localDestino =  JPATH_ROOT.DS."media".DS."getmailing".DS. $nomeArquivo;

        $dirTemp = $arquivo['tmp_name'];

        if ( $extensao == "xml") {

            if(JFile::upload($dirTemp, $localDestino)) {

                $db =& JFactory::getDBO();

                $docXML = simplexml_load_file($localDestino);

                /*
                 * Varre o vetor, e a cada iteração, adiciona no BD os registros
                */
                foreach ($docXML->registro as $registro) {

                    $query = "insert into #__getmailing (nome, email, uid, published, hits, data_cadastro) values ('" . $registro->nome . "', '" . $registro->email . "', '" . $registro->uid . "'," . $registro->published . "," . $registro->hits . ",'" . $registro->data_cadastro . "');";

                    $db->setQuery($query);
                    //Se conseguir executar a query, então terá restaurado tudo corretamente, mantendo a variável $retorno com seu valor inicial, true;
                    if(!$db->query()) {
                        $retorno = false;
                    }

                } //foreach

            }
            else {
                $retorno = false;
            }

        }
        else {
            $retorno = false;
        }

        return $retorno;

        exit;

    }

}



?>