<?php

defined('_JEXEC') or die('Acesso restrito ao Joomla!');
define( 'YOURBASEPATH', dirname(__FILE__) );

jimport('joomla.application.component.controller');
jimport('joomla.filesystem.file');
jimport('joomla.utilities.utility');

//include_once(JPATH_ROOT . DS . "administrator" . DS . "components" . DS . "com_getmailing" . DS . "includes" . DS . "getmailing.class.php");

//Para a classe JTable funcionar, deve-se importá-la aqui...
JTable::addIncludePath(JPATH_COMPONENT.DS.'tables');

class GetMailingController extends JController {

    function  __construct($default = array()) {

        parent::__construct($default);

        $this->registerTask('enviar_cadastro', 'enviarCadastro'); //$this->registerTast('task enviada', 'function chamada pela task');
		$this->registerTask('validar_cadastro', 'validarCadastro');
		$this->registerTask('remover_cadastro', 'removerCadastro');
		$this->registerTask('validar_remover_cadastro', 'validarRemoverCadastro');
		
    }
	
	
	/* Enviando o cadastro */
	function enviarCadastro(){
	
		global $option, $mainframe;

        JRequest::checkToken() or die ('Token Inválido'); //Se o Token não foi gerado pelo Joomla, cancelará a operação.
		
		$objTable =& JTable::getInstance('getmailing', 'Table'); //Cria uma instancia da classe TableGetMailing, obtendo o vínculo com a tabela #__getmailing
		
		if(!$objTable->bind(JRequest::get('post'))) { //liga o array dos elementos gerados por POST  aos atributos da classe TableMymural
            echo "<script> alert('" . $objTable->getError() . "'); window.history.go(-1);</script>\n";
            exit();
        }
		
		
		/* Capturando os dados enviados no formulário de cadastro */
		$nome =  JRequest::getVar('nome_getmailing', '', 'post', 'string', JREQUEST_ALLOWRAW);
        $email = JRequest::getVar('email_getmailing', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$uid = md5(time()); //Gerando código único, que servirá para validar o cadastro na hora de confirmar o mesmo
		
		
		/*Antes de fazer as validações necessários, é importante verificar se já existe um usuário com este email cadastrado. se sim, aí retorna o erro. */							
		
		$db =& JFactory::getDBO();

		$query = "SELECT email FROM #__getmailing WHERE email = '$email'";
		$db->setQuery($query);
		$texto = $db->loadResult();

		if($db->getErrorNum()) {
			echo $db->stderr();
			return false;
		}
		
		if($texto != ""){
		
			$msg = JText::_('Atenção: Já existe um usuário com este e-mail cadastrado. Tente novamente!');		
			$mainframe->enqueueMessage($msg, 'error');			
			$link = 'index.php?option=' . $option . '&view=cadastro';
			$this->setRedirect($link);			
			
		}
		else{		
		
			/* Adicionando os valores coletados aos parâmetros da classe Table */		
			$objTable->nome = $nome;
			$objTable->email = $email;
			$objTable->uid = $uid;
			$objTable->published = '0';
			$objTable->data_cadastro = date('Y-m-d H:i:s');
			
			
			$msg = JText::_('Cadastro efetuado com sucesso! <strong>Acesse seu e-mail para confirmar seu cadastro.</strong>');
			
			/* Fazendo a validação dos campos */
			if(trim($nome) == "" || $nome == null) {
				$erro = true;
				$msg = JText::_('Atenção: O campo NOME deve ser preenchido!');
			}
			
			else if(trim($email) == "" || $email == null) {
				$erro = true;
				$msg = JText::_('Atenção: O campo E-MAIL deve ser preenchido!');				
			}
	
			else if(!eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$", $email)) {
				$erro = true;
				$msg = JText::_('Atenção: E-MAIL inválido! Tente novamente');
			}
			
			//Fim da validação da consistência dos campos, agora é hora de cadastrar na tabela o registro
			else if(!$objTable->store()) {
				echo "<script> alert('" . $row->getError() . "'); window.history.go(-1);</script>\n";
				exit();        
			}
			
			//Após efetuar o cadastro, o sistema envia o e-mail para confirmação do usuário		
			else{
	
				//Código para envio do email, gerar código de validação de cadastro, etc...		
				global $option;		
				
				$db =& JFactory::getDBO();			
				
				//Capturando o texto de confirmação, configurado no Backend do componente.
				$query = "SELECT params FROM #__components WHERE admin_menu_link = 'option=com_getmailing&task=texto_email_confirmacao&controller=getmailing'";
				$db->setQuery($query);
				$texto = $db->loadResult();
		
				if($db->getErrorNum()) {
					echo $db->stderr();
					return false;
				}
		
				//Email do administrador do Joomla	
				$config =& JFactory::getConfig();
				$emailFrom =  $config->getValue( 'config.mailfrom' );	
					
				
				//Capturando o título do componente, para enviar como FromName no email
				$params =& JComponentHelper::getParams( 'com_getmailing' );
				$tituloComponente = $params->get( 'titulo_getmailing' );
				
	
				//Definindo data e hora do cadastro
				$dataAtual = date('Y-m-d H:i:s');
				$dataEnvio = substr($dataAtual, 8, 2) . '/' . substr($dataAtual, 5, 2) . '/' . substr($dataAtual, 0, 4) . ' - ' . substr($dataAtual, 11, 2) . ':' . substr($dataAtual, 14, 2) . "hs"; //2010-08-03 12:03:50 
			
				//Capturando o endereço do site, e adaptando o link para o arquivo de validação
				$link = JURI::base() . "index.php?option=" . $option . "&task=validar_cadastro&check=" . md5($email) . "&uid=" . $uid;
				$textoLink = JURI::base() . "get_mailing/validar_cadastro/" . $uid;
				$linkAtivacao = "<a href='" . $link . "' title='Clique aqui para ativar seu cadastro...'>" . $textoLink . "</a>";
			
				//Criando o email e seus dados			
				$from = $emailFrom;
				$fromname = $tituloComponente;
				$recipient = $email;
				$subject = 'Confirme seu cadastro';
				$body = $texto . '<br /><br />
				<strong>Detalhes de seu cadastro</strong><br />
				Nome: '. $nome . '<br />
				E-mail: ' . $email . '<br />
				Data de Cadastro: ' . $dataEnvio . '<br /><br /><br />
				Para confirmar seu cadastro, clique no link abaixo:<br />' . 
				$linkAtivacao;
				
				//Chamando a função sendMail, da classe JUtility, responsável pelo envio do email de confirmação.
				JUtility::sendMail($from, $fromname, $recipient, $subject, $body, $mode=true, $cc=null, $bcc=null, $attachment=null, $replyto=null, $replytoname=null);											
				
				
				//Ser a validação encontrar algum erro, irá exibir a mensagem de erro somente
				if($erro == true){
					$link = 'index.php?option=' . $option. '&view=cadastro';	
					
					$mainframe->enqueueMessage($msg, 'error');
					$this->setRedirect($link);			
				}
				else{
					$link = 'index.php?option=' . $option. '&view=confirmacao';	
				
					$this->setRedirect($link);
				}
			
			}//else
			
			
		}//else
		
	}//enviarCadastro()
	
	
	
	function validarCadastro(){
		
		global $option, $mainframe;
		
		/* Capturando os dados enviados pelo email */
		//$email =  JRequest::getVar('email', '', 'get', 'string', JREQUEST_ALLOWRAW);
        $check =  JRequest::getVar('check', '', 'get', 'string', JREQUEST_ALLOWRAW);
		$uid = JRequest::getVar('uid', '', 'get', 'string', JREQUEST_ALLOWRAW);
	
		
		$db =& JFactory::getDBO();	
		
		//Verificando se o registro existe.
		$query = "SELECT id FROM #__getmailing WHERE md5(email) = '" . $check ."' AND uid='" . $uid . "'";
		$db->setQuery($query);
		$idCadastro = $db->loadResult();

		if($db->getErrorNum()) {
			echo $db->stderr();
			return false;
		}
		
		if($idCadastro == ""){
		
			$link = 'index.php?option=' . $option. '&view=cadastro';			
			
			$msg = JText::_("Erro ao ativar seu cadastro. Tente se cadastrar novamente!");
			$mainframe->enqueueMessage($msg, 'error');
			$this->setRedirect($link);
					
			
		} //if($idCadastro == "")		
		else{
		
			$objTable =& JTable::getInstance('getmailing', 'Table'); //Cria uma instancia da classe TableGetMailing, obtendo o vínculo com a tabela #__getmailing
		
			if(!$objTable->bind(JRequest::get('post'))) { //liga o array dos elementos gerados por POST  aos atributos da classe TableMymural
				echo "<script> alert('" . $objTable->getError() . "'); window.history.go(-1);</script>\n";
				exit();
			}
			
			$objTable->id = $idCadastro;
			$objTable->published = '1';
			
			//Atualiza o registro, ativando-o, e se isso der certo, irá enviar o email de resposta sucesso
			if(!$objTable->store()) {
				echo "<script> alert('" . $row->getError() . "'); window.history.go(-1);</script>\n";
				exit();        
			}
			else{
			
				//Capturando o texto do email de sucesso, configurado no Backend do componente.
				$query = "SELECT params FROM #__components WHERE admin_menu_link = 'option=com_getmailing&task=texto_email_sucesso&controller=getmailing'";
				$db->setQuery($query);
				$texto = $db->loadResult();
		
				if($db->getErrorNum()) {
					echo $db->stderr();
					return false;
				}
			
				//Capturando os dados do registro, para enviar no email.
				$query = "SELECT * FROM #__getmailing WHERE id = " . $idCadastro;
				$db->setQuery($query);
				$registro = $db->loadObject();
		
				if($db->getErrorNum()) {
					echo $db->stderr();
					return false;
				}				

				//Email do administrador do Joomla	
				$config =& JFactory::getConfig();
				$emailFrom =  $config->getValue( 'config.mailfrom' );	
					
				
				//Capturando o título do componente, para enviar como FromName no email
				$params =& JComponentHelper::getParams( 'com_getmailing' );
				$tituloComponente = $params->get( 'titulo_getmailing' );
				
				
				$dataCadastro = substr($registro->data_cadastro, 8, 2) . '/' . substr($registro->data_cadastro, 5, 2) . '/' . substr($registro->data_cadastro, 0, 4) . ' - ' . substr($registro->data_cadastro, 11, 2) . ":" . substr($registro->data_cadastro, 14, 2) . "hs"; //2010-08-03 12:03:50 

			
				//Criando o email e seus dados			
				$from = $emailFrom;
				$fromname = $tituloComponente;
				$recipient = $registro->email;
				$subject = 'Cadastro confirmado com sucesso!';
				$body = $texto . '<br /><br /><strong>Detalhes de seu cadastro:</strong><br />
				Nome: '. $registro->nome . '<br />
				E-mail: ' . $registro->email . '<br />
				Data de Cadastro: ' . $dataCadastro . '<br /><br /><br />
				
				<p style="font-size:10px; color:#999;">Observação:<br />
				Caso deseje remover seu cadastro de nosso sistema, acesse <a href="' . JURI::base() . 'index.php?option=' . $option . '&view=cadastro" title="Remover cadastro">este link</a>, clique na aba <em>Remover</em>, informe seu e-mail e clique no botão <strong>Remover</strong>.</p>
				';
				
				
				//Chamando a função sendMail, da classe JUtility, responsável pelo envio do email de confirmação.
				JUtility::sendMail($from, $fromname, $recipient, $subject, $body, $mode=true, $cc=null, $bcc=null, $attachment=null, $replyto=null, $replytoname=null);	
				
				
				$link = 'index.php?option=' . $option. '&view=sucesso';			

				$this->setRedirect($link);
			
			}
		}
		
	}
	
	
	function removerCadastro(){
	
		global $option, $mainframe;

        JRequest::checkToken() or die ('Token Inválido'); //Se o Token não foi gerado pelo Joomla, cancelará a operação.
		
		$objTable =& JTable::getInstance('getmailing', 'Table'); //Cria uma instancia da classe TableGetMailing, obtendo o vínculo com a tabela #__getmailing
		
		if(!$objTable->bind(JRequest::get('post'))) { //liga o array dos elementos gerados por POST  aos atributos da classe TableMymural
            echo "<script> alert('" . $objTable->getError() . "'); window.history.go(-1);</script>\n";
            exit();
        }
		
		
		/* Capturando os dados enviados no formulário de remoção de cadastro */		
        $email = JRequest::getVar('email_getmailing_remover', '', 'post', 'string', JREQUEST_ALLOWRAW);

		
		
		/*Antes de fazer as validações necessários, é importante verificar se já existe um usuário com este email cadastrado. se sim, aí retorna o erro. */							
		
		$db =& JFactory::getDBO();

		$query = "SELECT email FROM #__getmailing WHERE email = '$email'";
		$db->setQuery($query);
		$email = $db->loadResult();

		if($db->getErrorNum()) {
			echo $db->stderr();
			return false;
		}
		
		if($email == "" || $email == null){
		
			$msg = JText::_('Atenção: Não foi encontrado em nosso sistema um usuário com este e-mail. Tente novamente!');		
			$mainframe->enqueueMessage($msg, 'error');			
			$link = 'index.php?option=' . $option . '&view=cadastro';
			$this->setRedirect($link);			
			
		}
		else{
		
			//Capturando os dados do registro, para enviar no email.
				$query = "SELECT * FROM #__getmailing WHERE email = '" . $email . "'";
				$db->setQuery($query);
				$registro = $db->loadObject();
		
				if($db->getErrorNum()) {
					echo $db->stderr();
					return false;
				}				

				//Email do administrador do Joomla	
				$config =& JFactory::getConfig();
				$emailFrom =  $config->getValue( 'config.mailfrom' );
				$nomeSite =  $config->getValue( 'config.fromname' );	
					
				
				//Capturando o título do componente, para enviar como FromName no email
				$params =& JComponentHelper::getParams( 'com_getmailing' );
				$tituloComponente = $params->get( 'titulo_getmailing' );
				
				
				$dataCadastro = substr($registro->data_cadastro, 8, 2) . '/' . substr($registro->data_cadastro, 5, 2) . '/' . substr($registro->data_cadastro, 0, 4) . ' - ' . substr($registro->data_cadastro, 11, 2) . ":" . substr($registro->data_cadastro, 14, 2) . "hs"; //2010-08-03 12:03:50 

				//Capturando o endereço do site, e adaptando o link para o arquivo de validação
				$link = JURI::base() . "index.php?option=" . $option . "&task=validar_remover_cadastro&check=" . md5($email) . "&uid=" . $registro->uid;
				$textoLink = JURI::base() . "get_mailing/remover_cadastro/" . $uid;
				$linkRemocao = "<a href='" . $link . "' title='Clique aqui para ativar seu cadastro...'>" . $textoLink . "</a>";
			
				//Criando o email e seus dados			
				$from = $emailFrom;
				$fromname = $tituloComponente;
				$recipient = $registro->email;
				$subject = 'Remoção de cadastro em Mailing!';
				$body = '<h3>' . $nomeSite . '</h3>' . JURI::base() . '<br /><br />Olá.<br />
				Você solicitou a remoção de seu cadastro em nosso Mailing.<br /><br />				
				<strong>Detalhes de seu cadastro:</strong><br />
				Nome: '. $registro->nome . '<br />
				E-mail: ' . $registro->email . '<br />
				Data de Cadastro: ' . $dataCadastro . '<br /><br /><br />
				
				<strong>Caso não tenha feito esta solicitação, simplesmente ignore este mensagem!</strong><br /><br />
				
				Para confirmar a remoção de seu cadastro em nosso Mailing, clique no link abaixo:<br />
				' . $linkRemocao;
				
				
				//Chamando a função sendMail, da classe JUtility, responsável pelo envio do email de confirmação.
				JUtility::sendMail($from, $fromname, $recipient, $subject, $body, $mode=true, $cc=null, $bcc=null, $attachment=null, $replyto=null, $replytoname=null);	
				
				
				$msg = JText::_('Atenção: Acesse seu e-mail para confirmar a remoção de seu cadastro!');		
				$mainframe->enqueueMessage($msg, 'Message');			
				$link = 'index.php?option=' . $option . '&view=cadastro';
				$this->setRedirect($link);
			
		}
	
	}
	
	
	function validarRemoverCadastro(){
	
		global $option, $mainframe;
		
		/* Capturando os dados enviados pelo email */
		//$email =  JRequest::getVar('email', '', 'get', 'string', JREQUEST_ALLOWRAW);
        $check =  JRequest::getVar('check', '', 'get', 'string', JREQUEST_ALLOWRAW);
		$uid = JRequest::getVar('uid', '', 'get', 'string', JREQUEST_ALLOWRAW);
	
		
		$db =& JFactory::getDBO();	
		
		//Verificando se o registro existe.
		$query = "SELECT id FROM #__getmailing WHERE md5(email) = '" . $check ."' AND uid='" . $uid . "'";
		$db->setQuery($query);
		$idCadastro = $db->loadResult();

		if($db->getErrorNum()) {
			echo $db->stderr();
			return false;
		}
		
		if($idCadastro == "" || $idCadastro == null){
		
			$link = 'index.php?option=' . $option. '&view=cadastro';			
			
			$msg = JText::_("Não existe em nosso sistema um usuário com este e-mail!");
			$mainframe->enqueueMessage($msg, 'error');
			$this->setRedirect($link);
					
			
		} //if($idCadastro == "")		
		else{
		
			$query = "DELETE FROM #__getmailing WHERE id = " . $idCadastro;
			$db->setQuery($query);
			
			if(!$db->query()) {
			
				$link = 'index.php?option=' . $option. '&view=cadastro';
				
                $msg = JText::_("Houve um erro ao remover seu cadastro. Tente novamente ou entre em contato conosco!");
				$mainframe->enqueueMessage($msg, 'error');
				$this->setRedirect($link);
            }
			else{
			
				$link = 'index.php?option=' . $option. '&view=cadastro';
				
				$msg = JText::_("Cadastro removido com sucesso!");
				$mainframe->enqueueMessage($msg, 'Message');
				$this->setRedirect($link);
				
			}	
		
		}
	
	
	}
	
	
	//Function para enviar os e-mails.
	function sendMail($from, $fromname, $recipient, $subject, $body, $mode=0, $cc, $bcc=null, $attachment=null, $replyto=null, $replytoname=null)
	{
		// Get a JMail instance
		$mail = &JFactory::getMailer();

		$mail->setSender(array($from, $fromname));
		$mail->setSubject($subject);
		$mail->setBody($body);

		// Are we sending the email as HTML?
		if ($mode) {
			$mail->IsHTML(true);
		}

		$mail->addRecipient($recipient);
		$mail->addCC($cc);
		$mail->addBCC($bcc);
		$mail->addAttachment($attachment);

		// Take care of reply email addresses
		if (is_array($replyto)) {
			$numReplyTo = count($replyto);
			for ($i=0; $i < $numReplyTo; $i++){
				$mail->addReplyTo(array($replyto[$i], $replytoname[$i]));
			}
		} elseif (isset($replyto)) {
			$mail->addReplyTo(array($replyto, $replytoname));
		}

		return  $mail->Send();
	}

}

?>